#include "datetime.h"

datetime_get_increment_type (dt, mode, from, to, fracsec)
    DateTime *dt;
    int *mode, *from, *to, *fracsec;
{
    if (!datetime_is_valid_type(dt))
	return datetime_error_code();

    *mode = DATETIME_RELATIVE;
    *to   = dt->to;
    *fracsec = dt->fracsec;

    if (datetime_is_absolute(dt))
    {
	if(datetime_in_interval_year_month(dt->to))
	    *from = DATETIME_YEAR;
	else
	    *from = DATETIME_DAY;
    }
    else
    {
	*from = dt->from;
    }
    return 0;
}

datetime_set_increment_type (src, incr)
    DateTime *src, *incr;
{
    int mode, from, to, fracsec;

    if(datetime_get_increment_type (src, &mode, &from, &to, &fracsec) != 0)
	return datetime_error_code();
    return datetime_set_type(incr, mode, from, to, fracsec);
}
