#include "datetime.h"

static int
have(x,dt)
    int x;
    DateTime *dt;
{
    return datetime_is_between(x, dt->from, dt->to);
}

datetime_check_timezone (dt, minutes)
    DateTime *dt;
    int minutes;
{
    if (!datetime_is_absolute(dt))
	return datetime_error(-1, "datetime not absolute");
    if (!have(DATETIME_MINUTE, dt))
	return datetime_error(-2, "datetime has no minute");
    if (!datetime_is_valid_timezone(minutes))
	return datetime_error(-3, "invalid datetime timezone");
    return 0;
}

datetime_get_timezone(dt, minutes)
    DateTime *dt;
    int *minutes;
{
    int stat;
    stat = datetime_check_timezone(dt, dt->tz);
    if (stat == 0)
	*minutes = dt->tz;
    return stat;
}

datetime_set_timezone (dt, minutes)
    DateTime *dt;
    int minutes;
{
    int stat;
    stat = datetime_check_timezone(dt, minutes);
    if (stat == 0)
	dt->tz = minutes;
    return stat;
}

datetime_unset_timezone (dt)
    DateTime *dt;
{
    dt->tz = -9999;
}

datetime_is_valid_timezone (minutes)
    int minutes;
{
    return (minutes >= -720 && minutes <= 780);
}
